<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="工单名称" prop="repairName">
        <el-input
          v-model="queryParams.repairName"
          placeholder="请输入工单名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="工单编号" prop="repairCode">
        <el-input
          v-model="queryParams.repairCode"
          placeholder="请输入工单编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间">
        <el-date-picker
          v-model="dateRange"
          size="small"
          style="width: 240px"
          value-format="yyyy-MM-dd"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item label="工单状态" prop="orderStatus">
        <el-select v-model="queryParams.orderStatus" placeholder="请选择工单状态" clearable size="small">
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="repairOrderList" @selection-change="handleSelectionChange">
      <el-table-column label="工单名称" align="center" prop="repairName" />
      <el-table-column label="工单编号" align="center" prop="repairCode" />
      <el-table-column label="设备名称" align="center" prop="deviceName" />
      <el-table-column label="设备编号" align="center" prop="deviceCode" />
      <el-table-column label="现场照片" align="center" prop="fileUrl" >
        <template slot-scope="scope">
          <img :src="scope.row.fileUrl" style="width: 20%;vertical-align:middle;cursor:pointer;" @click="showPicture(scope.row)"/>
          <el-image :ref="'a'+scope.row.id" :src="scope.row.fileUrl" v-show="false" :preview-src-list="[scope.row.fileUrl]" v-if="scope.row.fileUrl != '' && scope.row.fileUrl != null"></el-image>
        </template>
      </el-table-column>
      <el-table-column label="故障描述" align="center" prop="troubleDescribe" />
      <el-table-column label="工单状态" align="center" prop="orderStatus" :formatter="statusFormat" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-if="scope.row.orderStatus == '0'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            v-if="scope.row.orderStatus == '0'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleConfirm(scope.row)"
          >确认维修</el-button>
          <el-button
            v-if="scope.row.orderStatus == '1'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleMaintain(scope.row)"
          >维修完成</el-button>
          <el-button
            v-if="scope.row.orderStatus == '2'"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleCheck(scope.row)"
          >验收</el-button>
          <el-button
            v-if="scope.row.orderStatus == '0'"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备维修工单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-row>
          <el-col :span="11">
            <el-form-item label="工单名称" prop="repairName">
              <el-input v-model="form.repairName" placeholder="请输入工单名称" :disabled="readOnly" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="特种设备" prop="deviceId">
              <el-select v-model="form.deviceId" placeholder="请选择特种设备" filterable clearable style="width: 100%" :disabled="readOnly">
                <el-option
                  v-for="item in specialDeviceList"
                  :key="item.id"
                  :label="item.deviceName"
                  :value="item.id"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="23">
            <el-form-item label="上传现场照片" v-if="!readOnly" prop="fileUrl">
              <MyFileUpload
                listType="picture-card"
                @resFun="getFileInfo"
                @remove="listRemove"
                :fileArr="fileList"
              />
              <el-input v-show="false" disabled v-model="form.fileUrl"></el-input>
            </el-form-item>
            <el-form-item label="上传现场照片" v-if="readOnly" prop="fileUrl" >
              <img :src="form.fileUrl" style="width: 20%;vertical-align:middle;cursor:pointer;" @click="showPicture(form)"/>
              <el-image :zIndex="9999" :ref="'a'+form.id" :src="form.fileUrl" v-show="false" :preview-src-list="[form.fileUrl]" v-if="form.fileUrl != '' && form.fileUrl != null"></el-image>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="23">
            <el-form-item label="故障描述" prop="troubleDescribe">
              <el-input type="textarea" v-model="form.troubleDescribe" placeholder="请输入内容" :disabled="readOnly" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row v-show="operate">
          <el-col :span="23">
            <el-form-item label="验收结果" prop="orderStatus">
              <el-radio v-model="form.orderStatus" label="3">通过</el-radio>
              <el-radio v-model="form.orderStatus" label="0">未通过</el-radio>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="23">
            <el-form-item label="备注信息" prop="remarks">
              <el-input type="textarea" v-model="form.remarks" placeholder="请输入备注信息" :disabled="!readOnly" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRepairOrder, getRepairOrder, delRepairOrder, addRepairOrder, updateRepairOrder, exportRepairOrder } from "@/api/deviceManagement/repairOrder";
import { listSpecial } from "@/api/deviceManagement/deviceInfo";
import MyFileUpload from '@/components/MyFileUpload';


export default {
  name: "RepairOrder",
  components: {
    MyFileUpload
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备维修工单表格数据
      repairOrderList: [],
      // 特种设备列表
      specialDeviceList: [],
      statusOptions: [],
      // 日期范围
      dateRange: [],
      // 上传文件列表
      fileList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      operate: false,
      readOnly: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        repairName: null,
        repairCode: null,
        deviceId: null,
        troubleDescribe: null,
        fileUrl: null,
        orderStatus: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        repairName: [
          { required: true, message: "请输入工单名称", trigger: "blur" }
        ],
        deviceId: [
          { required: true, message: "请选择特种设备", trigger: "blur" }
        ],
        troubleDescribe: [
          { required: true, message: "请输入故障描述", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getSpecialDeviceList();
    this.getDicts("t_order_status").then(response => {
      this.statusOptions = response.data;
    });
  },
  methods: {
    // 计划状态
    statusFormat(row, column) {
      return this.selectDictLabel(this.statusOptions, row.orderStatus);
    },
    /** 查询设备维修工单列表 */
    getList() {
      this.loading = true;
      listRepairOrder(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.repairOrderList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getSpecialDeviceList() {
      this.loading = true;
      listSpecial().then(response => {
        this.specialDeviceList = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        repairName: null,
        repairCode: null,
        deviceId: null,
        troubleDescribe: null,
        fileUrl: null,
        orderStatus: null,
        isDel: null,
        createTime: null,
        updateTime: null,
        remarks: null
      };
      this.resetForm("form");
      this.fileList = [];
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.readOnly = false;
      this.operate = false;
      this.reset();
      this.open = true;
      this.title = "添加设备维修工单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.readOnly = false;
      this.operate = false;
      this.reset();
      const id = row.id || this.ids
      getRepairOrder(id).then(response => {
        this.form = response.data;
        if (this.form.fileUrl) {
          this.fileList.push({
            url: this.form.fileUrl,
          });
        }
        this.open = true;
        this.title = "修改设备维修工单";
      });
    },
    /** 验收按钮操作 */
    handleCheck(row) {
      this.readOnly = true;
      this.reset();
      const id = row.id || this.ids
      getRepairOrder(id).then(response => {
        this.form = response.data;
        if (this.form.fileUrl) {
          this.fileList.push({
            url: this.form.fileUrl,
          });
        }
        this.form.orderStatus = '3';
        this.operate = true;
        this.open = true;
        this.title = "验收设备维修工单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            if(this.operate) {
              updateRepairOrder(this.form).then(response => {
                this.msgSuccess("验收成功");
                this.open = false;
                this.operate = false;
                this.readOnly = false;
                this.getList();
              });
            } else {
              updateRepairOrder(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            }
          } else {
            addRepairOrder(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 确认维修按钮操作 */
    handleConfirm(row) {
      // const ids = row.id || this.ids;
      this.$confirm('是否确认开始执行编号为"' + row.repairCode + '"的设备维修工单?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        row.orderStatus = '1';
        return updateRepairOrder(row);
      }).then(() => {
        this.getList();
        this.msgSuccess("确认成功");
      }).catch(() => {});
    },
    /** 维修完成按钮操作 */
    handleMaintain(row) {
      // const ids = row.id || this.ids;
      this.$confirm('是否确认完成编号为"' + row.repairCode + '"的设备维修工单?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        row.orderStatus = '2';
        return updateRepairOrder(row);
      }).then(() => {
        this.getList();
        this.msgSuccess("确认成功");
      }).catch(() => {});
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      // const ids = row.id || this.ids;
      this.$confirm('是否确认删除设备维修工单编号为"' + row.repairCode + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          row.isDel = '1';
          return updateRepairOrder(row);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    showPicture(row){
      this.$refs['a'+row.id].showViewer = true;
      console.log("===",row.id);
    },
    getFileInfo(res){
      this.form.fileUrl = res.url;
    },
    listRemove(e) {
      this.form.fileUrl = "";
      this.fileList = [];
    },
    checkFile(url) {
      window.open(url,'_blank');
    },
  }
};
</script>
